my $APP_NAME 	= "";
my $APP_UID  	= "";
my $SDK_DRIVE 	= "d";
my $SDK_PATH 	= "\\Symbian\\UIQ_2.1\\";

my $foo = "$SDK_DRIVE:$SDK_PATH"."epoc32";
die "Cannot find directory $foo.\nPlease edit this script to match the location of your SDK installation." unless( -d $foo );

my $DEF 	= sprintf("0x%04x%04x",rand(2**12),rand(2**16) ) unless $APP_UID;
use File::Copy;

print<<eol;
Creating a new UIQ Symbian C++ project
Enter the name of the project. NOTE! Name of the project will be the name 
of the main class, and also the name of the project directory. 
Please don't use anything but alphanumeric characters here.
eol

print "--> Name of the project:";
$APP_NAME = <STDIN>; chop( $APP_NAME );
die( "The project must have a name") unless $APP_NAME;

print "\nEnter the UID of the project (If you don't have any valid UID's\n";
print "leave this field blank and the script will generate a valid developer UID).\n";
print "You can request UID's (for free) from www.symbian.com\n\n";
print "NOTE! NEVER publish any software with developer UID's!\n";
print "UID is a 4 byte unique identifier. Give the UID in hex format (i.e. 0x00ffee11)\n";
print "--> UID ($DEF): ";
$APP_UID = <STDIN>; chop($APP_UID);
$APP_UID = $DEF unless $APP_UID;

print "\n\nAbout to create a new project:\n";
print "Project name: $APP_NAME\n";
print "Product   ID: $APP_UID\n";
print "Continue? (y/n): ";

my $answer = <STDIN>;
chop $answer;


die unless (($answer eq "y") || ($answer eq "Y"));

die("$APP_NAME already exists\n") if( chdir $APP_NAME );
mkdir $APP_NAME,0755 || die("Couldn't mkdir $APP_NAME");
chdir "_TMPL" || die("Couldn't chdir to _TMPL");
&copyTo( "../$APP_NAME" );
chdir "..";

#chdir "$APP_NAME" || die("Couldn't chdir to $APP_NAME");
#print "\n\nRunning aifbuilder\n";
#system("aifbuilder -generate $APP_NAME.aifb");
  
chdir "$APP_NAME\\group" || die("Couldn't chdir to $APP_NAME\\group");
print "\n\nRunning bldmake bldfiles\n";
system("bldmake bldfiles");
chdir "..";
chdir "..";
  
print<<eol;

---------------------------------------------------------------------
Looking good. The directory hierarchy is as follows:
  $APP_NAME ("Project root" directory)
  +---src       : source files should be placed here
  |
  +---inc     	: header files should be placed here
  |
  +---group 	: build scripts and the generated .sis are here
  |
  +---data      : additional data (images and stuff) should be placed here
  
Commands you can execute in "Project root" directory:
'c'       : compiles the project to targer device, makes a sis and installs sis
          
Go ahead and 'cd $APP_NAME\\group', and type 'c' now

-draven
eol

sub copyTo
{
	my $dirTo = shift;
	mkdir($dirTo,0755);	
	my @files = <*>;
	for $file (@files)
	{
		if( chdir ( $file ) )
		{
			print "Entering directory $file\n";
			&copyTo("../".$dirTo."/$file");
			chdir "..";
			print "Leaving directory $file\n";
		}
		else
		{
			$_ = $file;
			if( /(.+)\.tmpl$/ )
			{
				$fileTo = $1;
				$fileTo =~ s/APP_NAME/$APP_NAME/g;

				print "Processing template for $fileTo\n";
				open( FILEIN, $file ) || die;
				open( FILEOUT, "> $dirTo/$fileTo" ) || die;
				while( $line = <FILEIN> )
				{
					$line =~ s/\<--SDK_DRIVE-->/$SDK_DRIVE/g;
					$line =~ s/\<--SDK_PATH-->/$SDK_PATH/g;
					$line =~ s/\<--PROJECT_PATH-->/$PROJECT_PATH/g;
					$line =~ s/\<--APP_NAME-->/$APP_NAME/g;
					$line =~ s/\<--APP_UID-->/$APP_UID/g;
					print FILEOUT $line;
				}
				close FILEOUT;
				close FILEIN;
			}
			else
			{
				print "Copying $file\n";
				copy($file, "$dirTo/$file");
			}
			
			
		}
					
	}
	
	
}

